"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTypedDocOnce = exports.useTypedDoc = void 0;
const reactfire_1 = require("reactfire");
const useSnapData_js_1 = require("./useSnapData.js");
const utils_js_1 = require("./utils.js");
const createUseTypedDocHook = (hook) => {
    return (typedDoc, dataOptions = {}) => {
        const { safeRef } = (0, utils_js_1.useSafeRef)(typedDoc.raw);
        const { data: _snap, error, ...status } = hook(safeRef, { suspense: true });
        (0, utils_js_1.useFirestoreErrorLogger)(error);
        const { snap, data } = (0, useSnapData_js_1.useDocumentSnapData)(typedDoc, _snap, dataOptions);
        return { snap, data, error, ...status };
    };
};
exports.useTypedDoc = createUseTypedDocHook(reactfire_1.useFirestoreDoc);
exports.useTypedDocOnce = createUseTypedDocHook(reactfire_1.useFirestoreDocOnce);
