"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTypedQuery = void 0;
const reactfire_1 = require("reactfire");
const useSnapData_js_1 = require("./useSnapData.js");
const utils_js_1 = require("./utils.js");
const useTypedQuery = (typedQuery, dataOptions = {}) => {
    const { safeRef } = (0, utils_js_1.useSafeRef)(typedQuery.raw);
    const { data: _snap, error, ...status } = (0, reactfire_1.useFirestoreCollection)(safeRef, { suspense: true });
    (0, utils_js_1.useFirestoreErrorLogger)(error);
    const { snap, data } = (0, useSnapData_js_1.useQuerySnapData)(typedQuery, _snap, dataOptions);
    return { snap, data, error, ...status };
};
exports.useTypedQuery = useTypedQuery;
