import React, { Suspense } from 'react';
import { useTypedDoc, useTypedQuery } from '../hooks/index.js';
import { typedFirestore } from './1-3-typed-firestore.js';
/**
 * Get realtime updates of collection/query
 */
export const UsersComponent = () => {
    const users = useTypedQuery(typedFirestore.collection('users'));
    return (React.createElement(Suspense, { fallback: 'Loading...' },
        React.createElement("ul", null, users.data.map((user, i) => (React.createElement("li", { key: i }, user.displayName))))));
};
/**
 * Get realtime updates of document
 */
export const UserComponent = ({ id }) => {
    var _a;
    const user = useTypedDoc(typedFirestore.collection('users').doc(id));
    return (React.createElement(Suspense, { fallback: 'Loading...' },
        React.createElement("span", null, (_a = user.data) === null || _a === void 0 ? void 0 : _a.displayName)));
};
