import { useFirestoreCollection } from 'reactfire';
import { useQuerySnapData } from './useSnapData.js';
import { useFirestoreErrorLogger, useSafeRef } from './utils.js';
export const useTypedQuery = (typedQuery, dataOptions = {}) => {
    const { safeRef } = useSafeRef(typedQuery.raw);
    const { data: _snap, error, ...status } = useFirestoreCollection(safeRef, { suspense: true });
    useFirestoreErrorLogger(error);
    const { snap, data } = useQuerySnapData(typedQuery, _snap, dataOptions);
    return { snap, data, error, ...status };
};
